(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2013 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: patchwork_types.mli,v 1.1 2013/06/13 19:01:17 fclement Exp $ *)

(*
type 'a piece = private
  {
   piece_number : Unatural.t;
   piece_value : 'a;
  }
;;
*)

type 'a t =
  | Piece of 'a (*'a piece*)
  | Stitch of 'a patchwork_step

and 'a patchwork_step =
  {
   patch : 'a t;
   weave : 'a t;
  }
;;
(** Patchworks are binary trees with values at the leafs, not at the nodes. *)

type 'a location =
  {
   above : 'a step list;
   here : 'a t;
  }

and 'a step =
  | Patch of 'a t
  | Weave of 'a t
;;
(** The zipper for patchworks. *)
