(* Beginning of ocamlprintc.bin generated code *)

let rec print_set pp_a ppf = function
  | Uset_types.Empty a_u_t ->
    Format.fprintf ppf "@[<1>%s@ " "Empty";
    Uuniverse_print.print_t pp_a ppf a_u_t; Format.fprintf ppf "%,@]"
  | Uset_types.Nonempty a_n ->
    Format.fprintf ppf "@[<1>%s@ " "Nonempty"; print_nonempty pp_a ppf a_n;
    Format.fprintf ppf "%,@]"

and print_nonempty pp_a ppf = function
  | { Uset_types.support = a_u_t; Uset_types.indices = a_u_t_a; } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>support =@ ";
    Uuniverse_print.print_t pp_a ppf a_u_t; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>indices =@ ";
    Lib_print.print_Array (Uindex_print.print_t pp_a) ppf a_u_t_a;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

(* End of ocamlprintc.bin generated code *)
